; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER_AKTIVIEREN:
;																			
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)		
;																			
; TIMSK ==> OCIE2 TOIE2 TICIE1 OCIE1A OCIE1B TOIE1 R TOIE0  				
;																			
	ldi temp,(0<<OCIE2)|(0<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(1<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIMER0_INITIALISIERUNG:
; TIMER0 (8Bit) Vorteiler													
;																			
; CS02 CS01 CS00 	Description												
;	0 	0 	0 		No clock source (Timer/Counter stopped).				
;	0 	0 	1 		clkI/O/		(No prescaling)								
;	0 	1 	0 		clkI/O/8 	(From prescaler)							
; *	0 	1 	1 		clkI/O/64 	(From prescaler)							
; 	1 	0 	0 		clkI/O/256 	(From prescaler)							
; 	1 	0 	1 		clkI/O/1024 (From prescaler)							
;	1 	1 	0 		External clock source on T0 pin. Clock on falling edge.	
;	1 	1 	1 		External clock source on T0 pin. Clock on rising edge.	
	ldi temp,(0<<CS02)|(1<<CS01)|(1<<CS00)
	OUT TCCR0,temp
; TIMER0 Startwert		
	ldi temp, TIMERWERT0
	out TCNT0,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TIM0_OVF:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
	push TEMP1
; ----------------------------------
; TIMER0 Startwert					
	ldi temp, TIMERWERT0
	out TCNT0,temp
; ZHLER							
TIM0_OVF_ZAHLER:
	; ZHLER+1		
	LDS temp,(adr_LED_DIGIT_ZAEHLER)
	inc temp
	STS(adr_LED_DIGIT_ZAEHLER),temp 
	; vergleich		
	cpi temp,4
	brlo TIM0_OVF_Z_FERTIG
	; NULL			
	STS(adr_LED_DIGIT_ZAEHLER),NULL
TIM0_OVF_Z_FERTIG:
; ----------------------------------
	rcall DIGIT
; ----------------------------------
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT_ALLES_AUS:
	cbi PORT_DIG_1,PIN_DIG_1
	cbi PORT_DIG_2,PIN_DIG_2	
	cbi PORT_DIG_3,PIN_DIG_3	
	cbi PORT_DIG_4,PIN_DIG_4	
	cbi PORT_DIG_5,PIN_DIG_5	
	cbi PORT_DIG_6,PIN_DIG_6	
	cbi PORT_DIG_7,PIN_DIG_7	
	cbi PORT_DIG_8,PIN_DIG_8	

	sbi PORT_BALKEN_A,PIN_BALKEN_A	
	sbi PORT_BALKEN_B,PIN_BALKEN_B	
	sbi PORT_BALKEN_C,PIN_BALKEN_C	
	sbi PORT_BALKEN_D,PIN_BALKEN_D	
	sbi PORT_BALKEN_E,PIN_BALKEN_E	
	sbi PORT_BALKEN_F,PIN_BALKEN_F	
	sbi PORT_BALKEN_G,PIN_BALKEN_G	
	sbi PORT_BALKEN_P,PIN_BALKEN_P

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT_WERT_LADEN:
	LDS temp,(adr_LED_DIGIT_ZAEHLER)
	cpi temp,0
	breq DIGIT_WERT_LADEN_0
	cpi temp,1
	breq DIGIT_WERT_LADEN_1
	cpi temp,2
	breq DIGIT_WERT_LADEN_2
	cpi temp,3
	breq DIGIT_WERT_LADEN_3
	cpi temp,4
	breq DIGIT_WERT_LADEN_4
	cpi temp,5
	breq DIGIT_WERT_LADEN_5
	cpi temp,6
	breq DIGIT_WERT_LADEN_6
	cpi temp,7
	breq DIGIT_WERT_LADEN_7
	ret
DIGIT_WERT_LADEN_0:
	LDS temp1,(adr_LED_BYTE_0)
	ret
DIGIT_WERT_LADEN_1:
	LDS temp1,(adr_LED_BYTE_1)
	ret
DIGIT_WERT_LADEN_2:
	LDS temp1,(adr_LED_BYTE_2)
	ret
DIGIT_WERT_LADEN_3:
	LDS temp1,(adr_LED_BYTE_3)
	ret
DIGIT_WERT_LADEN_4:
	LDS temp1,(adr_LED_BYTE_4)
	ret
DIGIT_WERT_LADEN_5:
	LDS temp1,(adr_LED_BYTE_5)
	ret
DIGIT_WERT_LADEN_6:
	LDS temp1,(adr_LED_BYTE_6)
	ret
DIGIT_WERT_LADEN_7:
	LDS temp1,(adr_LED_BYTE_7)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DIGIT:
	; ALLE DIGIT aus	
	cbi PORT_DIG_1,PIN_DIG_1
	cbi PORT_DIG_2,PIN_DIG_2	
	cbi PORT_DIG_3,PIN_DIG_3	
	cbi PORT_DIG_4,PIN_DIG_4
	cbi PORT_DIG_5,PIN_DIG_5	
	cbi PORT_DIG_6,PIN_DIG_6	
	cbi PORT_DIG_7,PIN_DIG_7	
	cbi PORT_DIG_8,PIN_DIG_8

	sbi PORT_BALKEN_A,PIN_BALKEN_A	
	sbi PORT_BALKEN_B,PIN_BALKEN_B	
	sbi PORT_BALKEN_C,PIN_BALKEN_C	
	sbi PORT_BALKEN_D,PIN_BALKEN_D	
	sbi PORT_BALKEN_E,PIN_BALKEN_E	
	sbi PORT_BALKEN_F,PIN_BALKEN_F	
	sbi PORT_BALKEN_G,PIN_BALKEN_G	
	sbi PORT_BALKEN_P,PIN_BALKEN_P
	; ZHLER			
	LDS temp,(adr_LED_DIGIT_ZAEHLER)
	cpi temp,0
	breq DIGIT_0
	cpi temp,1
	breq DIGIT_1
	cpi temp,2
	breq DIGIT_2
	cpi temp,3
	breq DIGIT_3

	cpi temp,4
	breq DIGIT_4
	cpi temp,5
	breq DIGIT_5
	cpi temp,6
	breq DIGIT_6
	cpi temp,7
	breq DIGIT_7
	ret

DIGIT_0:
	LDS temp1,(adr_LED_BYTE_0)
	rcall BALKEN
	sbi PORT_DIG_1,PIN_DIG_1	
	ret
DIGIT_1:
	LDS temp1,(adr_LED_BYTE_1)
	rcall BALKEN
	sbi PORT_DIG_2,PIN_DIG_2	
	ret
DIGIT_2:
	LDS temp1,(adr_LED_BYTE_2)
	rcall BALKEN
	sbi PORT_DIG_3,PIN_DIG_3	
	ret
DIGIT_3:
	LDS temp1,(adr_LED_BYTE_3)
	rcall BALKEN
	sbi PORT_DIG_4,PIN_DIG_4	
	ret
DIGIT_4:
	LDS temp1,(adr_LED_BYTE_4)
	rcall BALKEN
	sbi PORT_DIG_5,PIN_DIG_5	
	ret
DIGIT_5:
	LDS temp1,(adr_LED_BYTE_5)
	rcall BALKEN
	sbi PORT_DIG_6,PIN_DIG_6	
	ret
DIGIT_6:
	LDS temp1,(adr_LED_BYTE_6)
	rcall BALKEN
	sbi PORT_DIG_7,PIN_DIG_7	
	ret
DIGIT_7:
	LDS temp1,(adr_LED_BYTE_7)
	rcall BALKEN
	sbi PORT_DIG_8,PIN_DIG_8	
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BALKEN:
;-------------------------------------------------------------------------------
BALKEN_A:
	mov temp,temp1
	andi temp,0b00000001
	tst temp
	breq BALKEN_B
	cbi PORT_BALKEN_A,PIN_BALKEN_A	
;-------------------------------------------------------------------------------
BALKEN_B:
	mov temp,temp1
	andi temp,0b00000010
	tst temp
	breq BALKEN_C
	cbi PORT_BALKEN_B,PIN_BALKEN_B	
;-------------------------------------------------------------------------------
BALKEN_C:
	mov temp,temp1
	andi temp,0b00000100
	tst temp
	breq BALKEN_D
	cbi PORT_BALKEN_C,PIN_BALKEN_C	
;-------------------------------------------------------------------------------
BALKEN_D:
	mov temp,temp1
	andi temp,0b00001000
	tst temp
	breq BALKEN_E
	cbi PORT_BALKEN_D,PIN_BALKEN_D	
;-------------------------------------------------------------------------------
BALKEN_E:
	mov temp,temp1
	andi temp,0b00010000
	tst temp
	breq BALKEN_F
	cbi PORT_BALKEN_E,PIN_BALKEN_E	
;-------------------------------------------------------------------------------
BALKEN_F:
	mov temp,temp1
	andi temp,0b00100000
	tst temp
	breq BALKEN_G
	cbi PORT_BALKEN_F,PIN_BALKEN_F	
;-------------------------------------------------------------------------------
BALKEN_G:
	mov temp,temp1
	andi temp,0b01000000
	tst temp
	breq BALKEN_P
	cbi PORT_BALKEN_G,PIN_BALKEN_G	
;-------------------------------------------------------------------------------
BALKEN_P:
	mov temp,temp1
	andi temp,0b10000000
	tst temp
	breq BALKEN_FERTIG
	cbi PORT_BALKEN_P,PIN_BALKEN_P	
;-------------------------------------------------------------------------------
BALKEN_FERTIG:

ret
